<?php
if (php_sapi_name() === "cli") {
  define("SITE", $argv[1]);
  define("DESTINATION", $argv[2]);

  require "bibli/parsedown/Parsedown.php";
  require "bibli/parsedown-extra/ParsedownExtra.php";

  exec("/usr/bin/find " . SITE . " -name '*.gmi' -o -name '*.md'", $pages);

  require "inc/url.php";

  foreach ($pages as $page) {

    $pathParts = pathinfo($page);

    // Convert Gemtext to Markdown
    $gmilines = explode("\n", file_get_contents($page));

    if (substr($gmilines[0], 0, 2) === "# ")
      $title = substr($gmilines[0], 2);
    else
      $title = NULL;

    foreach ($gmilines as $key => $line) {
      if (substr($line, 0, 2) === "=>") {
        preg_match("/=> +(.[^ ]+)/", $line, $lnUrl);
        preg_match("/=> +.[^ ]+ +(.+)/", $line, $lnTitle);
        $mdSpecial = array("[", "]", "(", ")");
        $htmlEntities = array("&#91;", "&#93;", "&#40;", "&#41;");
        $lnUrl[1] = str_replace($mdSpecial, $htmlEntities, $lnUrl[1]);
        if (isset($lnTitle[1])) {
          $lnTitle[1] = str_replace($mdSpecial, $htmlEntities, $lnTitle[1]);
          $gmilines[$key] = "[" . $lnTitle[1] . "](" . $lnUrl[1] . ")";
        } else {
          $gmilines[$key] = "[" . $lnUrl[1] . "](" . $lnUrl[1] . ")";
        }
      }
    }
    $code = "";
    foreach ($gmilines as $line) {
      $code = $code . "\n" . $line;
    }

    // pages/exemple.md > temp/exemple.temp
    // Exécute le PHP vers du HTML
    ob_start();
    eval("?>" . $code);
    $contenuPage = ob_get_contents();
    ob_end_clean();

    // temp/exemple.temp > temp2/exemple.temp2
    // Compile le Markdown vers du HTML
    $Parsedown = new ParsedownExtra;
    $Parsedown = $Parsedown->setUrlsLinked(false);
    $Parsedown = $Parsedown->setMarkupEscaped(false);
    $Parsedown = $Parsedown->setBreaksEnabled(true);
    $contenuPage = $Parsedown->text($contenuPage);

    // temp2/exemple.temp2 > exemple.html
    // Ajoute header et footer au HTML
    ob_start();

    require "inc/debut.php";
    if ($pathParts['filename'] === "index") {
      echo "<div class='centre'>";
    } else {
      echo "<article>";
    }
    echo $contenuPage;
    if ($pathParts['filename'] === "index") {
      echo "</div>";
    } else {
      echo "</article>";
    }
    require "inc/footer.php";
    file_put_contents($pathParts['dirname'] . "/" . $pathParts['filename'] . ".html", ob_get_contents());
    ob_end_clean();

  }

  // exemple.html > exemple.html.gz
  // Compresse les fichiers textes statiques HTML & CSS
  exec('/usr/local/bin/static-compress -c zopfli "' . SITE . '/*.html" "' . SITE . '/*.js" "' . SITE . '/css/*.css"');
} else {
  exit("Must be run from CLI");
}
